import java.io.IOException;
import java.util.Scanner;

public class ThreatDetection2{
    public static void main(String[] args)throws IOException{
        Scanner input = new Scanner(System.in);
        Fingerprint original = new Fingerprint("Original.txt");
        System.out.print("Define a maximum # of tries: ");
        int maxTries = input.nextInt();
        int tries = 0;
        //Threat Detection 2.0
        System.out.print("Set up error threshold (%): ");
        double epsilon = input.nextDouble();
        while( tries <= maxTries ){
                if(tries >= maxTries){
                    System.out.println("Access Denied.");
                    break;
                }
                else{
                    System.out.print("Provide Fingerprint: ");
                    String file = input.next();
                    Fingerprint currentFingerprint = loadFingerprint(file);
                    if( computeImprecision(currentFingerprint,original) < epsilon && (tries < maxTries)){
                        System.out.print("Succeed Authentication.Accuracy: ");
                        System.out.printf("%.2f",(100.0 - computeImprecision(currentFingerprint,original)));
                        System.out.println();
                        break;
                    }
                    else{
                        tries++;
                    }
                }
                
            }
        
    }

     public static Fingerprint loadFingerprint(String fileName)throws IOException{
        return new Fingerprint(fileName);
        
    }

    public static double computeImprecision(Fingerprint fp,Fingerprint original){
        double counter = 0;
        for (int row = 0; row < fp.getData().length; row++) {
            for (int col = 0; col < fp.getData()[row].length; col++) {
                if( !( fp.getData()[row][col].equals(original.getData()[row][col]) ) ){
                    counter++;
                }
            }
        }
        double imprecision = (counter * 100) / original.getNumberOfPixels();
        return imprecision;

    }
}